// Igraca, ki igra melodijo.
// Naprava: Arduino Nano, ATmega328
//
// Priklop:
// - piezzo piskac priklopi na GND in D8
// - 4 x 1.5 V baterije (AAA) priklopi na GND in VIN

#include "pitches.h"
#define NO_SOUND 0 // pavza


// int melody[] so note v melodiji
// int noteDurations[] so vrste not: 4 = cetrtinka, 8 = osminka,...

// MELODIJA #1
// ===========
//int melody[] = { NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, NO_SOUND, NOTE_B3, NOTE_C4 };

//int noteDurations[] = { 4, 8, 8, 4, 4, 4, 4, 4 };


// MELODIJA #2
// ===========
//int melody[] = { NOTE_C4, NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_A3, NOTE_G3, NOTE_F3, NOTE_F3, NOTE_E3, NOTE_E3, NOTE_D3, NOTE_D3, NOTE_C4 };

//int noteDurations[] = { 8, 8, 8, 8, 8, 8, 4, 8, 8, 8, 8, 8, 8, 4 };


// MELODIJA #3 (Beverly Hills Cop)
// ===============================
int melody[] = { NOTE_D4, NO_SOUND, NOTE_F4, NOTE_D4, NO_SOUND, NOTE_D4, NOTE_G4, NOTE_D4, NOTE_C4, NOTE_D4, NO_SOUND, NOTE_A4, NOTE_D4, NO_SOUND, NOTE_D4, 
  NOTE_AS4, NOTE_A4, NOTE_F4, NOTE_D4, NOTE_A4, NOTE_D5, NOTE_D4, NOTE_C4, NO_SOUND, NOTE_C4, NOTE_A3, NOTE_E4, NOTE_D4, NO_SOUND };

int noteDurations[] = { 8, 8, 6, 16, 16, 16, 8, 8, 8, 8, 8, 6, 16, 16, 16, 8, 8, 8, 8, 8, 8, 16, 16, 16, 16, 8, 8, 2, 2 };


// MELODIJA #4 (Super Mario)
// =========================
//int melody[] = { NOTE_E7, NOTE_E7, 0, NOTE_E7, 0, NOTE_C7, NOTE_E7, 0, NOTE_G7, 0, 0,  0, NOTE_G6, 0, 0, 0,  NOTE_C7, 0, 0, NOTE_G6, 0, 0, NOTE_E6, 0, 0, NOTE_A6, 0, 
//  NOTE_B6, 0, NOTE_AS6, NOTE_A6, 0, NOTE_G6, NOTE_E7, NOTE_G7, NOTE_A7, 0, NOTE_F7, NOTE_G7, 0, NOTE_E7, 0,NOTE_C7, NOTE_D7, NOTE_B6, 0, 0, NOTE_C7, 0, 0, NOTE_G6, 0, 0, 
//  NOTE_E6, 0, 0, NOTE_A6, 0, NOTE_B6, 0, NOTE_AS6, NOTE_A6, 0, NOTE_G6, NOTE_E7, NOTE_G7, NOTE_A7, 0, NOTE_F7, NOTE_G7, 0, NOTE_E7, 0,NOTE_C7, NOTE_D7, NOTE_B6, 0, 0 };

//int noteDurations[] = { 12, 12, 12, 12,  12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 9, 9, 9,
//  12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 9, 9, 9, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12 };

void setup() {
    Serial.begin(9600);
    Serial.print("Igranje glasbe...\nMelodija ima: ");
    Serial.print(sizeof(melody)/2);
    Serial.print(" not.");
}

void loop() {
  // iterate over the notes of the melody:
    for (int thisNote = 0; thisNote < sizeof(melody)/2; thisNote++) {
        // izracunaj trajanje note
 
        int noteDuration = 1000 / noteDurations[thisNote];
        tone(8, melody[thisNote], noteDuration);
 
        // za vsako noto dodaj majhno pavzo, da se note ločijo med sabo
        // trajanje note + 30% deluje v redu:
        int pauseBetweenNotes = noteDuration * 1.30;
        delay(pauseBetweenNotes);
 
        // prenehaj z igranjem note
        noTone(8);
    }
    
  // pocakaj 15 sekund in ponovi igranje
  delay(15000);
}
